<script setup>
import useVuelidate from "@vuelidate/core";
import { required, email } from "@vuelidate/validators";
import { reactive, ref, computed } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import { mdiAccount, mdiAsterisk } from "@mdi/js";
import FullScreenSection from "@/components/FullScreenSection.vue";
import SectionComponent from "@/components/SectionComponent.vue";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import Field from "@/components/Field.vue";
import Control from "@/components/Control.vue";
import Divider from "@/components/Divider.vue";
import JbButton from "@/components/JbButton.vue";
import JbButtons from "@/components/JbButtons.vue";
import AuthService from "@/api/authService";
import { useToast } from "vue-toastification";
import VueMask from "v-mask";
import axios from "axios";
// import axios from 'axios';
const router = useRouter();
const store = useStore();
const toast = useToast();
// Validations
const user = reactive({
  email: "",
  password: "",
});
const rules = computed(() => {
  return {
    email: { required, email },
    password: { required },
  };
});
const v$ = useVuelidate(rules, user);
const submit = () => {
  // vuelidate validation
  v$.value.$validate();
  // if success
  if (!v$.value.$error) {
    AuthService.login(user)
      .then((response) => {
        console.log("response", response);
        if (response?.data?.success) {
          if (response?.headers?.authorization) {
            localStorage.setItem("lcg_token", response?.headers?.authorization);
            store.commit("setUser", {
              user: {},
              authKey: response?.headers?.authorization,
            });
          }

          toast.success("Logged in Successfully!");
          router.push({ path: `/dashboard/` });
          // setTimeout(() => {
          //   router.push({ path: `/dashboard/` });
          // }, 1000);
        } else {
          toast.error(response?.data?.message);
          return false;
        }
      })
      .catch((error) => {
        let message =
          error?.response?.data?.message || "something wrong! please try again";
        toast.error(message);
      });
  }
};
const hidePassword = ref(true);
const passwordFieldType = computed(() =>
  hidePassword.value ? "password" : "text"
);
</script>
<template>
  <full-screen-section
    v-slot="{ cardClass, cardRounded }"
    bg="login"
    class="h-full py-6 md:px-4 px-0 ffamily"
  >
    <div class="row w-full justify-between my-1 mb-4 px-32 py-10 h-full">
      <img src="@/assets/icons/logo.svg" />
    </div>
    <div class="flex justify-center justify-items-center">
      <div
        class="bg-white md:inline-flex md:px-14 px-2 py-20 w-4/5 rounded-lg shadow-pink-150 dropShadow-outer-lg"
      >
        <span class="md:w-1/2 w-full md:px-10 px-2">
          <h6
            class="text-center text-pink-250 ffamily font-semibold text-3xl mb-4"
          >
            "Labour Care Guide"
          </h6>
          <center class="py-10">
            <img
              src="@/assets/icons/login-icon.svg"
              style="height: 300px"
              alt="logo"
            />
          </center>
        </span>
        <section-component
          class="md:w-1/2 w-full py-2 md:px-16 px-0 shadow-none"
          :class="cardClass"
          :rounded="cardRounded"
          form
        >
          <h5 class="text-left text-pink-250 font-semibold text-3xl mb-4 pb-4">
            Login
          </h5>
          <div class="py-6">
            <field label="Email ID">
              <div class="flex-wrap">
                <control
                  v-model="user.email"
                  placeholder="Enter Email Id"
                  name="login"
                  autocomplete="username"
                  class="w-full"
                />
                <span class="text-pink-250" v-if="v$.email.$error">
                  {{ v$.email.$errors[0].$message }}
                </span>
              </div>
            </field>
            <field label="Password">
              <div class="flex-wrap">
                <control
                  id="password"
                  v-model="user.password"
                  placeholder="Password"
                  :type="passwordFieldType"
                  name="password"
                  autocomplete="current-password"
                />
                <span class="flex" @click="hidePassword = !hidePassword">
                  <img v-if="passwordFieldType == 'password'"
                  class="absolute mr-3 -mt-6 md:right-72 right-20 cursor-pointer"
                  src="@/assets/icons/eyes.svg"
                  
                />
                <img v-else
                  class="absolute mr-3 pb-2 -mt-7 md:right-72 right-20 cursor-pointer"
                  src="@/assets/icons/Close_eye.svg"
                  
                />
                </span>
                
                <span class="text-pink-250" v-if="v$.password.$error">
                  {{ v$.password.$errors[0].$message }}
                </span>
              </div>
            </field>
            <span class="flex justify-end items-end cursor-pointer -mt-2">
              <router-link
                class="text-gray-250 text-sm text-right font-semibold"
                to="/forget-password"
                >Forget Password</router-link
              >
            </span>
          </div>
          <jb-buttons>
            <jb-button
              @click.prevent="submit"
              color=""
              label="Login"
              class="mt-2 bg-pink-250 text-white w-full font-normal py-3 rounded-lg"
            />
          </jb-buttons>
        </section-component>
      </div>
    </div>
  </full-screen-section>
</template>
